﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Reports;

namespace LoadReportAndParamsRunTime
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<ComboReportData> data = new List<ComboReportData>();

            ComboReportData report1 = new ComboReportData
            {
                Name = "Report 1",
                ReportUri = new Uri("/LoadReportAndParamsRunTime;component/Report1.igr", UriKind.Relative),
                Parameters = new Dictionary<string, object>()
            };
            report1.Parameters.Add("ReportName", "Peter");
            report1.Parameters.Add("ReportContent", "This is a report for the work that Peter has completed during this week");
            data.Add(report1);



            ComboReportData report2 = new ComboReportData
            {
                Name = "Report 2",
                ReportUri = new Uri("/LoadReportAndParamsRunTime;component/Report2.igr", UriKind.Relative),
                Parameters = new Dictionary<string, object>()
            };
            report2.Parameters.Add("ID", "123444");
            report2.Parameters.Add("Name", "Peter");
            report2.Parameters.Add("ImageUrl", "http://www.codeproject.com/script/Membership/Uploads/4300443/Infragistics-logo.jpg");
            data.Add(report2);

            DataContext = data;
        }

        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ComboReportData data = e.AddedItems[0] as ComboReportData;            
           
            xamReportViewer1.Parameters.Clear();

            foreach (KeyValuePair<string,object> param in data.Parameters)
            {
                xamReportViewer1.Parameters.Add(
                    new Parameter
                    {
                        ParameterName = param.Key,
                        ParameterValue = param.Value
                    });
            }

            xamReportViewer1.RenderSettings = new ClientRenderSettings
            {
                DefinitionUri = data.ReportUri
            };
            

        }
    }

    public class ComboReportData
    {
        public string Name { get; set; }
        public Uri ReportUri { get; set; }
        public Dictionary<string,object> Parameters { get; set; }
    }
}
